
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Faq_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const faq_items = await db.faq_items.create(
            {
                id: data.id || undefined,
        
        question: data.question
        ||
        null
            ,
            
        answer: data.answer
        ||
        null
            ,
            
        faq_category: data.faq_category
        ||
        null
            ,
            
        is_published: data.is_published
        ||
        false
        
            ,
            
        sort_order: data.sort_order
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return faq_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const faq_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                question: item.question
            ||
            null
            ,
            
                answer: item.answer
            ||
            null
            ,
            
                faq_category: item.faq_category
            ||
            null
            ,
            
                is_published: item.is_published
            ||
            false
        
            ,
            
                sort_order: item.sort_order
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const faq_items = await db.faq_items.bulkCreate(faq_itemsData, { transaction });

        // For each item created, replace relation files
        

        return faq_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const faq_items = await db.faq_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.question !== undefined) updatePayload.question = data.question;
        
        
        if (data.answer !== undefined) updatePayload.answer = data.answer;
        
        
        if (data.faq_category !== undefined) updatePayload.faq_category = data.faq_category;
        
        
        if (data.is_published !== undefined) updatePayload.is_published = data.is_published;
        
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        updatePayload.updatedById = currentUser.id;

        await faq_items.update(updatePayload, {transaction});

        
        

        
        

        

        return faq_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const faq_items = await db.faq_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of faq_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of faq_items) {
                await record.destroy({transaction});
            }
        });


        return faq_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const faq_items = await db.faq_items.findByPk(id, options);

        await faq_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await faq_items.destroy({
            transaction
        });

        return faq_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const faq_items = await db.faq_items.findOne(
            { where },
            { transaction },
        );

        if (!faq_items) {
            return faq_items;
        }

        const output = faq_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.question) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'faq_items',
                        'question',
                        filter.question,
                    ),
                };
            }
            
            if (filter.answer) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'faq_items',
                        'answer',
                        filter.answer,
                    ),
                };
            }
            

            
            

            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.faq_category) {
                where = {
                    ...where,
                faq_category: filter.faq_category,
            };
            }
            
            if (filter.is_published) {
                where = {
                    ...where,
                is_published: filter.is_published,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.faq_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'faq_items',
                        'question',
                        query,
                    ),
                ],
            };
        }

        const records = await db.faq_items.findAll({
            attributes: [ 'id', 'question' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['question', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.question,
        }));
    }

    
};

